/*
 *  Copyright (C) 2009 Nicolas Vion <nico@picapo.net>
 *
 *   This file is part of Fluxy.
 *
 *   Fluxy is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   Fluxy is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Fluxy; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef _FLUXY_HH
#define _FLUXY_HH

#include <stdint.h>

#define BUFFER_SCALE_MIN 7 //min buffers size is 2^7 bytes (128 bytes)
#define BUFFER_SCALE_MAX 15 //max buffers size is 2^15 bytes (32768 bytes)
#define BUFFER_SCALE_SIZE(scale) (1 << scale)

#define USER_MESSAGES_SIZE 50

typedef uint32_t UserId;
typedef uint32_t UserFlags;
typedef uint32_t UserMessageId;
typedef uint8_t UserMessageType;
typedef uint32_t UserMessageFlags;
typedef uint8_t UserMessageVersion;
typedef int UserScore;
typedef uint8_t BufferScale;

#endif
